'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  svg: {
    width: 32,
    height: 32
  },
  outline: {
    stroke: '#ffffff',
    strokeWidth: 4.9,
    strokeMiterlimit: 4,
    strokeOpacity: 0.75,
    fill: 'none'
  },
  text: {
    fill: '#fff'
  }
};

var MarkerIcon = function MarkerIcon(_ref) {
  var _ref$style = _ref.style,
      style = _ref$style === undefined ? {} : _ref$style,
      _ref$color = _ref.color,
      color = _ref$color === undefined ? '#000000' : _ref$color,
      label = _ref.label;

  return _react2.default.createElement(
    'svg',
    {
      version: '1.1',
      style: (0, _objectAssign2.default)({}, styles.svg, style),
      viewBox: '0 0 40 40' },
    _react2.default.createElement('circle', {
      style: (0, _objectAssign2.default)({}, styles.outline, { fill: color }),
      r: '20',
      cx: '20',
      cy: '20'
    }),
    label && _react2.default.createElement(
      'text',
      { x: '20', y: '27', fontSize: '20', fontFamily: 'Roboto', textAnchor: 'middle', style: styles.text },
      label
    )
  );
};

exports.default = MarkerIcon;
//# sourceMappingURL=MarkerIcon.js.map