'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('@material-ui/core/styles');

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  root: {
    color: 'rgba(0, 0, 0, 0.67)',
    padding: '3px 5px',
    marginRight: 5,
    minHeight: 16,
    textTransform: 'initial',
    '& svg': {
      height: 18,
      width: 18,
      paddingRight: 6
    }
  }
};

var ToolbarButton = function ToolbarButton(props) {
  var children = props.children,
      classes = props.classes;

  var otherProps = (0, _omit2.default)(props, 'children', 'classes');
  return _react2.default.createElement(
    _Button2.default,
    (0, _extends3.default)({ className: classes.root }, otherProps),
    children
  );
};

ToolbarButton.propTypes = {
  children: _propTypes2.default.node.isRequired,
  classes: _propTypes2.default.object.isRequired
};

ToolbarButton.muiName = 'Button';

exports.default = (0, _styles.withStyles)(styles)(ToolbarButton);
//# sourceMappingURL=ToolbarButton.js.map