'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactRedux = require('react-redux');

var _MenuButton = require('../components/buttons/MenuButton');

var _MenuButton2 = _interopRequireDefault(_MenuButton);

var _filterable_features = require('../selectors/filterable_features');

var _filterable_features2 = _interopRequireDefault(_filterable_features);

var _field_analysis = require('../selectors/field_analysis');

var _field_analysis2 = _interopRequireDefault(_field_analysis);

var _mapbox_filter = require('../selectors/mapbox_filter');

var _mapbox_filter2 = _interopRequireDefault(_mapbox_filter);

var _action_creators = require('../action_creators');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function mapStateToProps(state) {
  return {
    filter: (0, _mapbox_filter2.default)(state),
    features: (0, _filterable_features2.default)(state),
    fieldAnalysis: (0, _field_analysis2.default)(state)
  };
}

function mapDispatchToProps(dispatch) {
  return {
    openSettings: function openSettings() {
      return dispatch((0, _action_creators.openSettings)('filters'));
    }
  };
}

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(_MenuButton2.default);
//# sourceMappingURL=ConnectMenuButton.js.map